# file-o-bot

### Problem
You have file objects in separate forms of storage (internal SSD, SFTP, S3, etc), but want to have a centralized directory to access all those files. You want to be able to shift these files across these storage solutions automatically.

### Hello file-o-bot
This script creates a folder with a huge list of soft links to every object across your storage mediums. You can also define "lifetimes" for each object in each form of storage such that it is slowly "downgraded" in storage priority as it becomes less and less accessed. This allows you to move those files transparently from faster storage to cheaper archive storage.

file-o-bot is inspired by the Autoclass feature of Google Cloud Storage buckets. file-o-bot is merely a redneck version of it.

### FAQ

#### What happens if files/folder structures overlap across my storage mediums?

Movements still apply to the files. 

Storage paths are sorted via the `sort` utility and the preceding paths have higher priority over subsequent ones. All storage paths are "merged"

For overlapping files, the file in the highest priority storage would be chosen to be soft-linked.

#### What kind of file protections do I have when executing movements?

None. The files are transferred using rsync but that's about it.

#### This is madness.

Yes.
